<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param vat_value=24 (VAT_VALUE) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param currency= (DEFAULT_CURRENCY) 
#
# 
######################################################################

// Current datafeed script version
define("SCRIPT_VERSION", "1.02");

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed Joomshopping</b><br />";
	echo "script version <b>" . SCRIPT_VERSION . "</b><br />";
	exit;
}

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);

$_SVR = array();

##### Include configuration files ################################################

# You need to do place this file in your root directory, where the configuration file is located.
# Otherwise, if you place this file in another directory please modify the line below with the path to the directory where the configuration file is located.
# In this case, $site_base_path should contain the path that is found in $mosConfig_absolute_path variable from the configuration.php file, followed by / 
$site_base_path = "./";

# Once all is set up you need to check the result and make sure the output is correct
# Point the browser to http://www.example.com/path_to_datafeed/shopmania_datafeed.php and look into the source code of the out put
# What you need to see is something like this
# Category | Manufacturer | Part Number | Merchant Code | Product Name | Product Description | Product URL | Product Image URL | Product Price | Currency 

##### Avoid any modifications below this line #####

$_SVR = array();

##### Include configuration files ################################################

define ( '_JEXEC', 1 );

define('JPATH_BASE', dirname(__FILE__) );

define( 'DS', DIRECTORY_SEPARATOR );

$hasShipping = false;

if (!file_exists(JPATH_BASE .DS.'includes'.DS.'defines.php')) {
  echo("An include file not found. Check the path.");
}

require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );

$mainframe =& JFactory::getApplication('site');
$mainframe->initialise();
$Config = new JConfig();

#########################################

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : ((@$_GET['description'] == "limited") ? "limited" : "on");
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$currency = (@$_GET['currency'] != "") ? strtoupper($_GET['currency']) : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$use_path = (@$_GET['usepath'] != "") ? $_GET['usepath'] : "";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$show_combinations = (@$_GET['combinations'] == "on") ? "on" : "off";
$show_attribute = (@$_GET['attribute'] == "on") ? "on" : "off";
####################################################################

// Force base path
if ($force_path == "on") {
	$mosConfig_live_site = ($use_path != "") ? $use_path : $_SERVER['HTTP_HOST'];
}

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
		
	echo "<b>Datafeed Joomshopping</b><br />";
	echo "script version <b>" . SCRIPT_VERSION . "</b><br /><br /><br />";
		
	//echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	//echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	//echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	//echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	//echo "<b>Discount options</b> - possible values on, off default value on<br />";
	//echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
	
	//echo "Add shipping to datafeed - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	//echo "<b>Display Description options</b> - possible values on, off, limited default value on<br />";
	//echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br />";
	//echo "<a href=\"" . $script_basepath . "?description=limited" . "\" >" . $script_basepath . "?description=limited" . "</a><br /><br />";
	
	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	//echo "<b>Show only on stock products</b> - possible values on, off default value off<br />";
	//echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	//echo "<b>Show SEO friendly url</b> - possible values on, off default value off<br />";
	//echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	//echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	//echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "Get texts in specified language code - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	//echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	//echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
	
	//echo "<b>Usepath - force defined basepath to product URL</b> - possible values ex: www.site.com<br />";
	//echo "usepath=BASEPATH <a href=\"" . $script_basepath . "?forcepath=on&usepath=http://www.site.com" . "\" >" . $script_basepath . "forcepath=on&usepath=http://www.site.com" . "</a><br /><br />";
	
	echo "<b>Display product combinations</b> - possible values on, off default value on<br />";
	echo "combinations=off (on,off) <a href=\"" . $script_basepath . "?combinations=on" . "\" >" . $script_basepath . "?combinations=on" . "</a><br /><br />";
	
	echo "<b>Display product attributess</b> - possible values on, off default value off<br />";
	echo "attribute=off (on,off) <a href=\"" . $script_basepath . "?attribute=on" . "\" >" . $script_basepath . "?attribute=on" . "</a><br /><br />";
	
	echo "<br />";
	exit;
	
}

##### Connect to  database ################################################

$confg['driver']   = $Config->dbtype;   // Database driver name
$confg['host']     = $Config->host;     // Database host name
$confg['user']     = $Config->user;     // User for database authentication
$confg['password'] = $Config->password; // Password for database authentication
$confg['database'] = $Config->db;       // Database name
$confg['prefix']   = $Config->dbprefix; // Database prefix

//$db = & JDatabase::getInstance ($confg);
$db = JFactory::getDBO();
######################################################################

##### Extract options from database ################################################

// Tables variables
$prod_table = $confg['prefix']  . "jshopping_products"; // products table
$cat_table = $confg['prefix'] . "jshopping_categories"; // categories table
$manuf_table = $confg['prefix'] . "jshopping_manufacturers"; // manufacturer table
$price_table = $confg['prefix'] . "jshopping_products_prices"; // product price table
$delivery_table = $confg['prefix'] . "jshopping_delivery_times"; // product manufacturer xref table
$prod_cat_xref_table = $confg['prefix'] . "jshopping_products_to_categories"; // product category xref table
$tax_table = $confg['prefix'] . "jshopping_taxes"; // tax rate table
$currency_table = $confg['prefix'] . "jshopping_currencies"; // currency table
$attribute_table = $confg['prefix'] . "jshopping_attr"; // prodcut attribute table
$attribute_values_table = $confg['prefix'] . "jshopping_products_attr"; // product attributes values table
$attr_values_table = $confg['prefix'] . "jshopping_attr_values"; // attribute values table

// Get currency
$query_curr = "SELECT currency_code_iso FROM " . $currency_table . " WHERE currency_id=1";
$db->setQuery($query_curr);
$currency = $db->loadResult();

######################################################################


##### Extract products from database ###############################################

$CAT_ARR = array();
$CAT_LIST = array();
// Get categories 
$rc = "SELECT category_id, `name_en-GB` as category_name, category_parent_id as parent_id FROM ".  $cat_table;
$db->setQuery($rc);
$CAT_LIST = $db->loadAssocList();

if (is_array($CAT_LIST) && sizeof($CAT_LIST) > 0 ) {
	foreach ($CAT_LIST as $i=>$v) {
		$CAT_ARR[$v['category_id']] = $v;
	}
}

$query = "SELECT prod.product_id, prod.product_ean, prod.product_quantity, prod.product_url, prod.image, prod.product_price, prod.`name_en-GB` as name, prod.`short_description_en-GB` as short_description, prod.`description_en-GB` as description, cat.`name_en-GB` as cat_name,	cat.category_id, manuf.`name_en-GB` as manufacturer, deliv.`name_en-GB` as delivery_time 
FROM $prod_table AS prod
LEFT JOIN $prod_cat_xref_table AS categ USING (product_id)
LEFT JOIN $cat_table as cat on cat.category_id=categ.category_id
LEFT JOIN $tax_table AS tax ON tax.tax_id = prod.product_tax_id
LEFT JOIN $manuf_table AS manuf ON manuf.manufacturer_id = prod.product_manufacturer_id
LEFT JOIN $delivery_table AS deliv ON deliv.id = prod.delivery_times_id
WHERE prod.product_publish = '1'
ORDER BY prod.product_id ASC, cat.category_id DESC";

$db->setQuery($query);
$products = $db->loadObjectList();

###################################################################


##### Print product data ####################################################

$current_id = 0;
foreach($products as $prod){
				
	// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
	$product_id = $prod->product_id;
	if ($current_id == $product_id) {
		continue;
	}
	else {
		$current_id = $product_id;
	}
	
	if ($show_combinations == 'on') {
		// Init vars
		$ATTR_LIST = array();
		$COMB_ARR = array();
		$ATTR_VAL_LIST = array();
				
		// Get the attributes ids for each product
		$attr_query = "SELECT * FROM " . $attribute_values_table . " WHERE product_id = " . $product_id;
		$db->setQuery($attr_query);
		$ATTR_LIST[] = $db->loadAssocList();

		if (is_array($ATTR_LIST) && sizeof($ATTR_LIST) > 0) {
			foreach ($ATTR_LIST AS $i => $v) { 
				foreach ($v as $k=>$combination) {
					$COMB_ARR[$combination['product_attr_id']]['variation_id'] = $combination['product_attr_id'];
					$COMB_ARR[$combination['product_attr_id']]['price'] = $combination['price'];
					$COMB_ARR[$combination['product_attr_id']]['ean'] = $combination['ean'];
				}
			}
		}
		
		// Get the attributtes values for each product
		$attr_val_query = "	SELECT product_attr_id, GROUP_CONCAT(`name_en-GB` SEPARATOR \", \") AS `attr_values` 
							FROM (
									(
									SELECT product_attr_id, product_id, attr_1, `name_en-GB`
									FROM " . $attribute_values_table ." 
									LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_1 = " . $attr_values_table . ".value_id)
									WHERE product_id = " . $product_id . "
									)
									UNION ALL
									(
									SELECT product_attr_id, product_id, attr_2, `name_en-GB`
									FROM " . $attribute_values_table ." 
									LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_2 = " . $attr_values_table . ".value_id)
									WHERE product_id = " . $product_id . "
									)
									UNION ALL
									(
									SELECT product_attr_id, product_id, attr_3, `name_en-GB`
									FROM " . $attribute_values_table ." 
									LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_3 = " . $attr_values_table . ".value_id)
									WHERE product_id = " . $product_id . "
									)
								) attr_table
						   GROUP BY product_attr_id   
						   ORDER BY product_attr_id;";
		
		$db->setQuery($attr_val_query);
		$ATTR_VAL_LIST = $db->loadAssocList();
		
		if (is_array($ATTR_VAL_LIST) && sizeof($ATTR_VAL_LIST) > 0) {
			foreach ($ATTR_VAL_LIST AS $i => $v) { 
				$COMB_ARR[$v['product_attr_id']]['name'] = $v['attr_values'];
			}
		}	
	}
	if ($show_attribute == "on") {
		// Init vars
		$ATTR_LIST = array();
		// Get the possible attributes list for each product
		$attr_list_query = " SELECT attr_name, GROUP_CONCAT(DISTINCT attr_vals SEPARATOR \", \") AS attr_values
							 FROM (
									(
										SELECT cgi50_jshopping_attr_values.`name_en-GB` AS `attr_vals`, cgi50_jshopping_attr.`name_en-GB` AS `attr_name`
										FROM " . $attribute_values_table ." 
										LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_1 = " . $attr_values_table . ".value_id)
										LEFT JOIN " . $attribute_table . " ON (" . $attribute_table . ".attr_id = " . $attr_values_table . ".attr_id)
										WHERE product_id = " . $product_id . "
										)
										UNION ALL
										(
										SELECT cgi50_jshopping_attr_values.`name_en-GB` AS `attr_vals`, cgi50_jshopping_attr.`name_en-GB` AS `attr_name`
										FROM " . $attribute_values_table ." 
										LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_2 = " . $attr_values_table . ".value_id)
										LEFT JOIN " . $attribute_table . " ON (" .$attribute_table. ".attr_id = " . $attr_values_table . ".attr_id)
										WHERE product_id = " . $product_id . "
										)
										UNION ALL
										(
										SELECT cgi50_jshopping_attr_values.`name_en-GB` AS `attr_vals`, cgi50_jshopping_attr.`name_en-GB` AS `attr_name`
										FROM " . $attribute_values_table ." 
										LEFT JOIN " . $attr_values_table . " ON (" . $attribute_values_table . ".attr_3 = " . $attr_values_table . ".value_id)
										LEFT JOIN " . $attribute_table . " ON (" . $attribute_table . ".attr_id = " . $attr_values_table . ".attr_id)
										WHERE product_id = " . $product_id . "
										)
									 ) attr_table
						GROUP BY attr_name;";
		
		$db->setQuery($attr_list_query);
		$ATTR_LIST = $db->loadAssocList();
		if (is_array($ATTR_LIST) && sizeof($ATTR_LIST) > 0) {
			foreach ($ATTR_LIST AS $i=>$v) { 
				$ATTR_TEMP[] = $v['attr_name'] . ": " . $v['attr_values'];
			}
			$attr = join("; ", array_values($ATTR_TEMP));
		}	
	}
	
	// Clean description
	$prod_desc = smfeed_clean_description($prod->short_description . " " . $prod->description);
	 
	$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
	$prod_desc = str_replace("\n", " ", $prod_desc);		
	$prod_desc = str_replace("\r", "", $prod_desc);
	$prod_desc = str_replace("\t", " ", $prod_desc);
	
	// Clean product name (new lines)
	$prod_name = str_replace("\n", "", strip_tags($prod->name));
	$prod_name = str_replace("\r", "", strip_tags($prod->name));
	$prod_name = str_replace("\t", " ", strip_tags($prod->name));
		
	$prod_price = $prod->product_price;
	
	// Add VAT to prices
	if ($add_vat == "on") {
		$prod_price = $prod_price * $vat_value;
	}

	$prod_image = ($show_image == "on") ? "http://" . $_SERVER['HTTP_HOST']. "/components/com_jshopping/files/img_products/" . $prod->product_full_image : "";
	$prod_url = "http://" . $_SERVER['HTTP_HOST']. "/index.php?option=com_jshopping&controller=product&task=view&category_id=". $prod->category_id . "&product_id=" . $prod->product_id;
	
	// Add GA Tagging parameters to url
	if ($add_tagging == "on") {
		$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
		$prod_url = $prod_url . $and_param . $tagging_params;
	}
	
	$category_name = smfeed_get_full_cat($prod->category_id, $CAT_ARR);
	
	// Clean product names and descriptions (separators)
	if ($datafeed_separator == "\t") {
		$category_name = str_replace("\t", " ", $category_name);
		// Continue... tabs were already removed
	}
	elseif ($datafeed_separator == "|") {
		$prod_name = str_replace("|", " ", strip_tags($prod_name));
		$prod_desc = str_replace("|", " ", $prod_desc);
		$category_name = str_replace("|", " ", $category_name);
	}
	else {
		print "Incorrect columns separator.";
		exit;		
	}
	
	// Output the datafeed content
	// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency
	if ($show_combinations == "on" && is_array($COMB_ARR) && sizeof($COMB_ARR) > 0) {
		foreach ($COMB_ARR AS $k => $combination) {
			print  
				$category_name . $datafeed_separator .
				$prod->manufacturer . $datafeed_separator .
				($combination['ean'] != "" ? $combination['ean'] : $prod->product_ean) . $datafeed_separator .
				$prod->product_id . "_". $combination['variation_id'] . $datafeed_separator . 
				$prod_name . ", " . $combination['name'] . $datafeed_separator . 
				$prod_desc . $datafeed_separator .
				$prod_url . $datafeed_separator .
				$prod_image . $datafeed_separator .
				$prod_price . $datafeed_separator . (($show_attribute == "on") ? $attr . $datafeed_separator . $currency : $currency) . "\n";
		}
	}	
	// Output the datafeed content
	// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency
	else {
		print
			$category_name . $datafeed_separator .
			$prod->manufacturer . $datafeed_separator .
			$prod->product_ean . $datafeed_separator .
			$prod->product_id . $datafeed_separator .
			$prod_name . $datafeed_separator .
			$prod_desc . $datafeed_separator .
			$prod_url . $datafeed_separator .
			$prod_image . $datafeed_separator .
			$prod_price . $datafeed_separator . (($show_attribute == "on") ? $attr . $datafeed_separator . $currency : $currency) . "\n";
	}			
}

###################################################################


##### Functions ########################################################

// Function to get category with full path
function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['category_name'];
	
	if (@$item_arr['parent_id'] > 0) {
		while (sizeof(@$CATEGORY_ARR[$item_arr['parent_id']]) > 0 && is_array(@$CATEGORY_ARR[$item_arr['parent_id']]) ) {
			
			$cat_name = $CATEGORY_ARR[$item_arr['parent_id']]['category_name'] . " > " . $cat_name;		
			$item_arr = $CATEGORY_ARR[$item_arr['parent_id']];
		}
	}
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_build_str_key($text){
	
	$text = str_replace(" ", "-", trim(smfeed_string_clean_search($text)));
	$text = rawurlencode(strtolower($text));
	
	$text = strtolower(smfeed_clean_accents($text));
	
	$text = rawurldecode($text);
	
	return $text;
}

function smfeed_clean_accents($text){

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// CLEANS STRINGS
function smfeed_string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"','",
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'='",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
		//"'\.'",
		//"'\+'",
		//"'/'",
	);
	
	$replace = array (
		"",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		//" ",
		//" ",
		//" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

exit;

?>